/*----------------------------------------------------------------------*
    ALLPIO.c
    [o̓|[g]
    Copyright (c) BestTechnology CO.,LTD. 2005-2013
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  XCb`ނ̏ԂLEDɔf܂B
  ----------------------------------------------------------------------
 yڍׁz
  vbV{^44bit̃fBbvXCb`̏Ԃ8LEDɊ蓖āA
  vbV{^ƃfBbvXCb`̏ԂɉLED_܂B

 yӁz
  18bit|[gɕ̋@\UĂ镔邽߁A1̋@
  \lăWX^ւ̃ANZXsƑ̋@\Q鎖
  ܂BړIƂȂrbgȊO͕ύXȂlɃrbg𕹗p
  ANZXKv܂B

  I/O|[ǵA
   LEDPA0`7փ\[Xڑ
   vbV{^PB0`PB3ɐڑAGNDɐڒn
   fBbvXCb`PD4`PD7ɐڑAONGNDɐڒn
  Ƃ܂B


  I/O|[gɊւ郌WX^(ׂ8rbg)
    |[gWX^  :DDR? (?̓|[g(A`D))
      ǒ͕ erbg0: 1:o
    |[go̓WX^:PORT? (?̓|[g(A`D))
      o͍\Ƀ|[go erbg0:HIGH 1:LOW
    |[g̓WX^  :PIN?
      ͍\Ƀ|[g erbg0:HIGH 1:LOW
    ȂADDR?̔CӃrbg0()PORT?̓rbg1ɂ
    vAbvONƂȂ

  ֗ȑgݍ݃}N ( avr\io.h Ȃ avr\sfr_defs.h Œ`)
    _BV(a)
      rbga𗧂Ăۂ̒l  Ⴆ _BV(3) = 0x8 ƂȂ
    bit_is_clear (x, y)
      xWX^yrbg0Ȃtrue
    bit_is_set (x, y)
      xWX^yrbg1Ȃtrue
    loop_until_bit_is_set(x, y)
      xWX^yrbg0̊ԑ҂
    loop_until_bit_is_clear(x,y)
      xWX^yrbg1̊ԑ҂

  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O

/*-----------------------------------------------*/
/* I/O|[gpTu[`                       */
/*-----------------------------------------------*/
// |[g̏
void InitPIO (void) {
  // LED(PA0..PA7)\
  DDRA = 0xff;  // PA0..7o͂
  PORTA = 0xff; // LEDOFF

  // fBbvXCb`(PD4..7)\
  DDRD &= ~(_BV(DD4) | _BV(DD5) | _BV(DD6) | _BV(DD7));         // PD4..7͂
  PORTD |= (_BV(PORT4) | _BV(PORT5) | _BV(PORT6) | _BV(PORT7)); // PD4..7̓vAbvRON

  // vbV{^(PB0..4)\
  DDRB &= ~(_BV(DD0) | _BV(DD1) | _BV(DD2) | _BV(DD3));         // PB0..3͂
  PORTB |= (_BV(PORT0) | _BV(PORT1) | _BV(PORT2) | _BV(PORT3)); // PB0..3̓vAbvRON
}

// lLED2i\
void LED (int d) {
  PORTA = ~d;
}

// fBbvXCb`̏Ԏ荞
unsigned char DIP1_STAT (void) {
  return (~(PIND >> 4)) & 0xf;
}

// vbV{^1̏Ԏ荞
unsigned char PB1_STAT (void) {
  return bit_is_clear (PINB, PIN0);
}

// vbV{^2̏Ԏ荞
unsigned char PB2_STAT (void) {
  return bit_is_clear (PINB, PIN1);
}

// vbV{^3̏Ԏ荞
unsigned char PB3_STAT (void) {
  return bit_is_clear (PINB, PIN2);
}

// vbV{^4̏Ԏ荞
unsigned char PB4_STAT (void) {
  return bit_is_clear (PINB, PIN3);
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void) {
  InitPIO ();

  for (;;) {
    // LEDɃvbV{^ƃfBbvXCb`̏Ԃ\
    LED ((DIP1_STAT () << 4) | (PB4_STAT () << 3) | (PB3_STAT () << 2) | (PB2_STAT () << 1) | PB1_STAT ());
  }
}
