/*----------------------------------------------------------------------*
    LED2.c
    [o̓|[g]
    Copyright (c) BestTechnology CO.,LTD. 2005-2013
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  4LEDCӂ̃p^[œ_܂B
  ----------------------------------------------------------------------
 yڍׁz
  {IȘ_ZgpLED_/܂B

 yӁz
  18bit|[gɕ̋@\UĂ镔邽߁A1̋@
  \lăWX^ւ̃ANZXsƑ̋@\Q鎖
  ܂BړIƂȂrbgȊO͕ύXȂlɃrbg𕹗p
  ANZXKv܂B

  LEDPA0`PA7փVNڑĂ̂ƂA0o͂ƏA1o
  ͂Ɠ_܂B

  I/O|[gɊւ郌WX^(ׂ8rbg)
    |[gWX^  :DDR? (?̓|[g(A`D))
      ǒ͕ erbg0: 1:o
    |[go̓WX^:PORT? (?̓|[g(A`D))
      o͍\Ƀ|[go erbg0:HIGH 1:LOW
    |[g̓WX^  :PIN?
      ͍\Ƀ|[g erbg0:HIGH 1:LOW
    ȂADDR?̔CӃrbg0()PORT?̓rbg1ɂ
    vAbvONƂȂ

  ֗ȑgݍ݃}N ( avr\io.h Ȃ avr\sfr_defs.h Œ`)
    _BV(a)
      rbga𗧂Ăۂ̒l  Ⴆ _BV(3) = 0x8 ƂȂ
    bit_is_clear (x, y)
      xWX^yrbg0Ȃtrue
    bit_is_set (x, y)
      xWX^yrbg1Ȃtrue
    loop_until_bit_is_set(x, y)
      xWX^yrbg0̊ԑ҂
    loop_until_bit_is_clear(x,y)
      xWX^yrbg1̊ԑ҂

  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O
#include <util/delay.h>     // ԑ҂[`
#include <math.h>           // w֐

/*-----------------------------------------------*/
/* I/O|[gpTu[`                       */
/*-----------------------------------------------*/
// |[g̏
void InitPIO (void) {
  // LED(PA0..7)\
  DDRA = 0xff;  // PA0..7o
  PORTA = 0xff; // LEDOFF
}

// lLED2i\
void LED (int d) {
  PORTA = ~d;
}

// 0.5ms̊ԂLEDONĂ銄ݒ
void duty (uint8_t *on) {
  int i;
  for (i = 0; i < 100; i++) {
    LED (
      ((on[0] > i) ? 1 : 0) |
      ((on[1] > i) ? 2 : 0) |
      ((on[2] > i) ? 4 : 0) |
      ((on[3] > i) ? 8 : 0) |
      ((on[4] > i) ? 16 : 0) |
      ((on[5] > i) ? 32 : 0) |
      ((on[6] > i) ? 64 : 0) |
      ((on[7] > i) ? 128 : 0)
    );
    _delay_us (5);
  }
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void) {
  int i;

  InitPIO ();

  while (1) {
    for (i = 0; i < 4; i++) {
      LED (0xff);
      _delay_ms (200);
      LED (0);
      _delay_ms (200);
    }

    for (i = 0; i < 4; i++) {
      LED (0b10011001);
      _delay_ms (200);
      LED (0b01100110);
      _delay_ms (200);
    }

    for (i = 0; i < 4; i++) {
      LED (0b00000001);
      _delay_ms (100);
      LED (0b00000010);
      _delay_ms (100);
      LED (0b00000100);
      _delay_ms (100);
      LED (0b00001000);
      _delay_ms (100);
      LED (0b00010000);
      _delay_ms (100);
      LED (0b00100000);
      _delay_ms (100);
      LED (0b01000000);
      _delay_ms (100);
      LED (0b10000000);
      _delay_ms (100);
      LED (0b01000000);
      _delay_ms (100);
      LED (0b00100000);
      _delay_ms (100);
      LED (0b00010000);
      _delay_ms (100);
      LED (0b00001000);
      _delay_ms (100);
      LED (0b00000100);
      _delay_ms (100);
      LED (0b00000010);
      _delay_ms (100);
    }

    for (i = 0; i < 256; i++) {
      LED (i);
      _delay_ms (20);
    }

    for (i = 0; i < 3000; i++) {
      uint8_t k[8];
      k[0] = 50 + cos(i / 60.0) * 50.0;
      k[1] = 50 + cos(i / 60.0 + 1.0 * M_PI / 4.0) * 50.0;
      k[2] = 50 + cos(i / 60.0 + 2.0 * M_PI / 4.0) * 50.0;
      k[3] = 50 + cos(i / 60.0 + 3.0 * M_PI / 4.0) * 50.0;
      k[4] = 50 + cos(i / 60.0) * 50.0;
      k[5] = 50 + cos(i / 60.0 + 1.0 * M_PI / 4.0) * 50.0;
      k[6] = 50 + cos(i / 60.0 + 2.0 * M_PI / 4.0) * 50.0;
      k[7] = 50 + cos(i / 60.0 + 3.0 * M_PI / 4.0) * 50.0;
      duty(k);
    }
  }
}
