/*----------------------------------------------------------------------*
    USART.c
    [VAʐM2]
    Copyright (c) BestTechnology CO.,LTD. 2005-2013
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  avr-lib̕WI/O[`gpāAR\[𐧌䂵܂B
  {Ismpl1ƓłALN^AA񃋁[`
  ɊւĂ͕WI/OCuoRĂ܂B
  ----------------------------------------------------------------------
 yڍׁz
  urs.hv͒ʐMsōŒKvȋ@\܂Ƃ߂Cu(libm32.a)
  ɒ`ꂽ֐̃wb_t@CłB
  ̃\[XincludeACuNΉL̊֐g
  ɂȂ܂B

 yӁz
  f[^̎Mɂ͊荞݂gpĂ邽߁AK荞݋sȂ
  B
  ܂AWI/OCũNTCY̓RpCIvVɂϓ
  ܂̂ŁAprɉēKXGCCǉIvVɒǋLĂB
  ڍׂavr-lib̃hLgQƂĂB

   1) vfprintfŐ̂݃T|[g
         -Wl,-u,vfprintf -lprintf_min
   2) vfprintfŕ_܂ŃT|[g
         -Wl,-u,vfprintf -lprintf_flt
   3) vfscanfŕ_܂ŃT|[g
         -Wl,-u,vfscanf -lscanf_flt
  ----------------------------------------------------------------------*/

#include <avr/io.h>         // I/O
#include <avr/interrupt.h>  // 荞݊֘A
#include <avr/wdt.h>        // EHb`hbO^C}
#include <rs.h>             // VAʐMCu

/*-----------------------------------------------*/
/* EFCg[` (^C}/JE^2gp)     */
/* w莞Ԍo߂܂ő҂                      */
/*-----------------------------------------------*/
void wait (unsigned long pause_ms) {
  unsigned long i;

  TCCR2 = 0x00;   // stop
  TCNT2 = 0;      // set count
  OCR2  = 0xfa;   // set compare
  TCCR2 = 0x0b;   // start timer clk/64

  for (i = 0; i < pause_ms; i++) {
    loop_until_bit_is_set(TIFR, OCF2);
    TIFR |= _BV(OCF2);
  }
  TCCR2 = 0x00;   // stop
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main (void) {
  static char txb[50],rxb[50];

  char  c;
  int   cnt = 0;
  int   n;

  rs0_init (br115200, txb, sizeof(txb), rxb, sizeof(rxb));

  // Wo͂libm128.ã[`Ɋ蓖
  fdevopen(rs0_putchar, rs0_getchar);

  sei ();

  puts ("\n<start>"); // puts͍ŌɉsR[hIɑ}܂

  // [v
  for (;;) {
    if (rs0_rx_buff () > 0) {  // Mobt@mF
      c = getchar ();         // 1M҂ & zXgփGR[obN
      cnt++;                  // 1͖ɃJE^CNg
      switch (c) {            // ͂ꂽɉbZ[W
        // 10iœ͕̃JEg\
        case 'D':
          printf ("\nkey input count = %d\n", cnt);
          break;
        // 16iœ͕̃JEg\
        case 'H':
          printf ("\nkey input count = 0x%05X\n", cnt);
          break;
        //  lϊ
        case 'S':
          printf ("\nPlease input n = ");
          if (scanf ("%d", &n) > 0) {
            printf ("\ninput n = %d\n", n);
            int i;
            for (i = 0; i < n && !rs0_rx_buff(); i++) putchar ('*');
            putchar ('\n');
          }
          break;
        // 10bԎMobt@|[g & obt@NA
        case 'P':
          for (n = 0; n < 100; n++) {
            printf ("\rrx buff=%d", rs0_rx_buff ());
            wait (100);
          }
          rs0_rx_purge ();
          printf("\npurge!\nrx buff=%d\n", rs0_rx_buff ());
          break;
        // ESCR[hŃvOI(WDTgăVXeZbg)
        case 0x1b:
          cli ();
          wdt_enable (WDTO_15MS);
          break;
      }
    }
  }
}
