/*----------------------------------------------------------------------*
    ADC.c
    [A/DRo[^]
    Copyright (c) BestTechnology CO.,LTD. 2005-2013
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  nCp[^[~i̒ʐM\tgɐڑĎgp܂B

  PF0`PF7(ADC0`ADC7)ɓ͂ꂽdMv\܂B
  ----------------------------------------------------------------------
 yڍׁz
  PF0`PF7̓AiO͒[qpA0`5V͈̔͂œ͂d
  ꂽA/DRo[^Ōvł܂Ba2d֐͎w肳ꂽ`lA/D
  sA0V0A5V1023Ԃ܂B

  dAVCC[qɋdƂĂ܂̂ŁAAVCC[q}CR
  {[hɋd(5V)Ɠ̂O狟ĂB

 yӁz
  mCYꍇAVCCɃtB^ꂽdڑĂB
  ----------------------------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <rs.h>

// Mpobt@
char txb[20], rxb[10];

/*-----------------------------------------------*/
/* I/O|[gpTu[`                       */
/*-----------------------------------------------*/
// |[g̏
void InitPIO (void) {
  // PB1..2(PB0..1)\
  DDRB &= ~(_BV(DD0) | _BV(DD1));     // PB0..1͂
  PORTB |= (_BV(PORT0) | _BV(PORT1)); // PB0..1̓vAbvRON
}

// PB1(vbVXCb`)̏Ԏ荞
unsigned char PB1_STAT (void) {
  return bit_is_clear (PINB, PIND0);
}

// PB2(vbVXCb`)̏Ԏ荞
unsigned char PB2_STAT (void) {
  return bit_is_clear (PINB, PIND1);
}

/*-----------------------------------------------*/
/* A/DRo[^pTu[`                   */
/*-----------------------------------------------*/
// A/DRo[^
void InitADC (void) {
  // A/Dϊ, ϊNbNCK/16
  ADCSRA = _BV(ADEN) | _BV(ADPS2);
}

// CCHA/Dϊ
unsigned short a2d (char ch) {
  ADMUX = _BV(REFS0) | (ch & 7);          // t@X,CHw
  ADCSRA |= _BV(ADSC);                    // ϊJn
  loop_until_bit_is_clear (ADCSRA, ADSC); // ϊI҂
  return ADC;
}

/*-----------------------------------------------*/
/* C                                        */
/*-----------------------------------------------*/
void main(void) {
  int ch, adv, intp, decip;

  InitPIO ();
  InitADC ();
  rs0_init (br115200, txb, sizeof(txb), rxb, sizeof(rxb));

  sei ();

  rs0_puts ("\n<start>\n");

  while (1) {   // [v
    // A/Dϊl̂
    if (PB1_STAT () && !PB2_STAT ()) {
      rs0_puts ("\rADC=[ ");
      for (ch = 0; ch < 8; ch++) {
        rs0_printf(" %4d%c", a2d (ch), (ch!=7)?',':' ');
      }
      rs0_puts ("] ");
    // A/Dϊdlɕϊ
    } else  if (!PB1_STAT () && PB2_STAT ()) {
      rs0_puts ("\rADC=[ ");
      for (ch = 0; ch < 8; ch++) {
        adv   = a2d(ch);
        intp  = adv * 5 / 1023;                         // dl̐1
        decip = (adv * 5 - intp * 1023) * 100L / 1023;  // dl̏2
        rs0_printf("%1d.%02dV%c", intp, decip, (ch!=7)?',':' ');
      }
      rs0_puts ("] ");
    }
    _delay_ms (50);
  }
}
